<?php defined('C5_EXECUTE') or die("Access Denied.");?>
<?php 
$configApiKey = Config::get('pixabay.apikey');
if(empty($configApiKey)){
    echo t('No API Key was detected... Go to the pixabay settings page in the dashboard for more information.');
}else{
?>
    <div class="pixabayedit<?php if (is_object($f)) {echo " pixaselected";}?>">
        <div class="filters">
            <input type="hidden" id="apikey" value="<?php echo $configApiKey; ?>"/>
            <input type="hidden" id="language" value="<?php echo Config::get('pixabay.language'); ?>"/>
            <input type="hidden" id="activepage" value="1"/>
            <input type="text" maxlength="100" name="question" class="form-control" id="question" placeholder="<?php echo t('Search'); ?>" value="<?php echo $imgTags; ?>"/>
            <select id="imagetype" class="form-control">
            <option value="all"><?php echo t('Type'); ?></option>
            <option value="all"><?php echo t('All'); ?></option>
            <option value="photo"><?php echo t('Photo'); ?></option>
            <option value="illustration"><?php echo t('Illustration'); ?></option>
            <option value="vector"><?php echo t('vector'); ?></option>
            </select>
            <select id="orientation" class="form-control">
            <option value="all"><?php echo t('Orientation'); ?></option>
            <option value="all"><?php echo t('All'); ?></option>
            <option value="horizontal"><?php echo t('Horizontal'); ?></option>
            <option value="vertical"><?php echo t('Vertical'); ?></option>
            </select>
            <a class="btn btn-warning" id="searchImg"><?php echo t('Search'); ?></a>
        </div>
        <div id="pixasearchresults">
            <div id="pixaresults"></div>
            <div id="pixaresultpagination"></div>
        </div>
        <div id="selection">
            <h3><?php echo t('Current image'); ?></h3>
            <div id="pixaimagedata">
            <div id="selectedimage">
                <?php
        if (is_object($f)) {
            echo '<img src="' . $f->getURL() . '"/>';
        }
        ?>
            </div>
            <div id="selectedalt">
                <label>
                <?php echo t('Image description'); ?><br/>
                <textarea id="imgAlt" class="form-control" name="imgAlt"><?php echo $imgAlt; ?></textarea>
                <input type="hidden" id="fileUrl" name="fileUrl"/>
                <input type="hidden" id="fID" name="fID" value="<?php echo $fID; ?>"/>
            </label>
            </div>
            </div>
        </div>
    </div>

    <script>
    //NEEDS TO BE PLACED INLINE DUE TO DYNAMIC EVENT LISTENERS
    function buildUrl(url, parameters) {
        let qs = "";
        for (const key in parameters) {
            if (parameters.hasOwnProperty(key)) {
                const value = parameters[key];
                qs += encodeURIComponent(key) + "=" + encodeURIComponent(value) + "&";
            }
        }
        if (qs.length > 0) {
            qs = qs.substring(0, qs.length - 1); //chop off last "&"
            url = url + "?" + qs;
        }

        return url;
    }

    function checkIfEmpty(stringValue){
        if(stringValue == '' || typeof stringValue == 'undefined' || stringValue == null || stringValue.length === 0 || !stringValue.trim()){
            return true;
        }else{
            return false;
        }
    }

    function fetchPixabayResources(){
        document.getElementById('pixasearchresults').style.display = 'block';
        document.getElementById('selection').style.display = 'none';

        let apikey = document.getElementById('apikey').value;
        let question = document.getElementById('question').value;
        let imagetype = document.getElementById('imagetype').value;
        let orientation = document.getElementById('orientation').value;
        let pagenumber = document.getElementById('activepage').value;
        let language = document.getElementById('language').value;

        if(checkIfEmpty(apikey)){
            alert("<?php echo t('No API Key was detected... Go to the pixabay settings page in the dashboard for more information.'); ?>");
        }else if(checkIfEmpty(question) || checkIfEmpty(imagetype) || checkIfEmpty(orientation)){
            alert("<?php echo t('All fields are required to start a search... Please check the fields.'); ?>")
        }else{
            let urlParams = {'key': apikey, 'q': question, 'image_type': imagetype, 'orientation': orientation, 'page': pagenumber, 'lang': language, 'per_page': 8};
            let fetchUrl = buildUrl('https://pixabay.com/api/', urlParams);

            fetch(fetchUrl).then(response => {
                if(response.status == 429){
                    return Promise.reject("<?php echo t('Too many requests on your API key!'); ?>");
                }
                if(response.status == 429){
                    return Promise.reject("<?php echo t('Too many requests on your API key!'); ?>");
                }
                return response.json();
            }).then(data => {
                let buildHtml = '';
                data.hits.forEach(function(item, index){
                    if(checkIfEmpty(item.fullHDURL)){
                        buildHtml += '<div data-large="' + item.largeImageURL + '" class="pixabay_image_preview">';
                    }else{
                        buildHtml += '<div data-large="' + item.fullHDURL + '" class="pixabay_image_preview">';
                    }
                    buildHtml += '<img src="' + item.previewURL + '"/>';
                    buildHtml += '</div>';
                });
                document.getElementById('pixaresults').innerHTML = buildHtml;

                let paginationHtml = '';
                let paginationMax = Math.ceil(parseInt(data.totalHits) / 8);
                if(paginationMax > 20){
                    paginationMax = 20;
                }
                for (let i = 1; i <= paginationMax; i++) {
                    if(i == pagenumber){
                        paginationHtml += '<div class="pixapage pixaactivepage" data-id="' + i + '">' + i + '</div>';
                    }else{
                        paginationHtml += '<div class="pixapage" data-id="' + i + '">' + i + '</div>';
                    }
                }
                document.getElementById('pixaresultpagination').innerHTML = paginationHtml;

                let activePages = document.getElementsByClassName("pixapage");
                for (let i = 0; i < activePages.length; i++) {
                    activePages[i].addEventListener('click', setPixaActivePage, false);
                }

                let pixaImages = document.getElementsByClassName("pixabay_image_preview");
                for (let i = 0; i < pixaImages.length; i++) {
                    pixaImages[i].addEventListener('click', setPixaImage, false);
                }

            }).catch(error => {
                alert("Error requesting images: " + error);
            });
        }
    }

    function setPixaImage(){
        let fullUrl = this.getAttribute("data-large");
        document.getElementById('selectedimage').innerHTML = '<img src="' + fullUrl + '"/>';
        document.getElementById('imgAlt').value = '';
        document.getElementById('fID').value = '';

        document.getElementById('fileUrl').value = fullUrl;

        document.getElementById('pixasearchresults').style.display = 'none';
        document.getElementById('selection').style.display = 'block';
    }

    function setPixaActivePage(){
        //set active page
        let pagenumber = this.getAttribute("data-id");
        document.getElementById('activepage').value = pagenumber;
        fetchPixabayResources();
    }

    document.getElementById('searchImg').addEventListener("click", function(evt){
        evt.preventDefault();
        evt.stopPropagation();

        document.getElementById('activepage').value = 1;
        fetchPixabayResources();
    });


    document.getElementById('question').addEventListener('keypress', function (e) {
        e.stopPropagation();
        var key = e.which || e.keyCode;
        if (key === 13) { // 13 is enter
            e.preventDefault();
            // code for enter
            document.getElementById('activepage').value = 1;
            fetchPixabayResources();
        }
    });

    </script>
<?php } ?>