<?php
namespace Concrete\Package\WebhappPixabay;

defined('C5_EXECUTE') or die('Access Denied.');

/*
 * Created by Jozzeh, Developer @ webhapp
 * Easily search and import pixabay images
 */

use Config;
use Page;
use SinglePage;
use \Concrete\Core\Block\BlockType\BlockType;
use \Concrete\Core\Package\Package;
use \Concrete\Core\File\Filesystem;
use \Concrete\Core\Tree\Node\Type\FileFolder;

class Controller extends Package
{
    protected $pkgHandle = 'webhapp_pixabay';
    protected $appVersionRequired = '8.0.0';
    protected $pkgVersion = '0.9.5';

    public function getPackageDescription()
    {
        return t('Easily search and use pixabay images.');
    }

    public function getPackageName()
    {
        return t('Webhapp Pixabay Image Import');
    }

    public function install()
    {
        $pkg = parent::install();
        $this->pixainstall($pkg);

        Config::save('pixabay.apikey', '');
        Config::save('pixabay.language', 'en');
        
    }

    public function update()
    {
        $pkg = Package::getByHandle('webhapp_pixabay');
        $this->pixainstall($pkg);
    }

    public function pixainstall($pkg){
        if (!BlockType::getByHandle('pixabay_image')) {
            BlockType::installBlockType('pixabay_image', $pkg);
        }

        $page = Page::getByPath('/dashboard/pixabay');
        if (!is_object($page) || $page->isError()) {
            SinglePage::add('/dashboard/pixabay', $pkg);
        }

        $page = Page::getByPath('/dashboard/pixabay/settings');
        if (!is_object($page) || $page->isError()) {
            SinglePage::add('/dashboard/pixabay/settings', $pkg);
        }

        $folder = FileFolder::getNodeByName("pixabay_import");
        if(!is_object($folder)){
            $filesystem = new Filesystem();
            $folder = $filesystem->getRootFolder();
            $folderName = "pixabay_import";
            $folder = $filesystem->addFolder($folder, $folderName);
        }
    }

    public function uninstall()
    {
        parent::uninstall();
        Config::clear('pixabay.apikey');
        Config::clear('pixabay.language');
    }
}
