<?php
namespace Concrete\Package\WebhappPixabay\Controller\SinglePage\Dashboard\Pixabay;

defined('C5_EXECUTE') or die('Access Denied.');

/*
 * Created by Jozzeh, Developer @ webhapp
 * Easily search and import pixabay images
 */

use Config;
use \Concrete\Core\Page\Controller\DashboardPageController;

class Settings extends DashboardPageController
{
    public function view()
    {
        $this->getSupportedLangauges();
    }

    public function save()
    {
        $this->view();
        $args = $this->post();
        if (!empty($args['pixapi'])) {
            Config::save('pixabay.apikey', $args['pixapi']);
        }
        if (!empty($args['pixalang'])) {
            Config::save('pixabay.language', $args['pixalang']);
        }
        if(!empty($args['pixapi']) && !empty($args['pixalang'])){
            $this->set('success', t('The settings are saved.'));
        }else{
            $this->set('message', t('Error: All fields need to have a value.'));
        }
    }

    public function getSupportedLangauges()
    {
        //official languages in order of appearance starting from UK
        $languages = array(
            'en' => t('English'),
            'nl' => t('Dutch'),
            'fr' => t('French'),
            'es' => t('Spanish'),
            'pt' => t('Portugese'),
            'de' => t('German'),
            'da' => t('Danish'),
            'no' => t('Norwegian'),
            'sv' => t('Swedish'),
            'fi' => t('Finish'),
            'it' => t('Italian'),
            'el' => t('Greek'),
            'tr' => t('Turkish'),
            'sk' => t('Slovak'),
            'hu' => t('Hungarian'),
            'cs' => t('Czech'),
            'pl' => t('Polish'),
            'bg' => t('Bulgarian'),
            'ro' => t('Romanian'),
            'ru' => t('Russian'),
            'id' => t('Indonesian'),
            'th' => t('Thai'),
            'ko' => t('Korean'),
            'vi' => t('Vietnamese'),
            'zh' => t('Chinese'),
            'ja' => t('Japanese'),
        );

        $this->set('languageList', $languages);
    }
}
